﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;

namespace Post5938.Web
{
    /// <summary>
    /// Summary description for WebService1
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class WebService1 : System.Web.Services.WebService
    {
        [WebMethod]
        public string GetFeatureByPosition(double x, double y)
        {
            ShapeFileFeatureLayer layer = GetLayer();
            layer.Open();
            Collection<Feature> features = layer.QueryTools.GetFeaturesContaining(new PointShape(x, y), ReturningColumnsType.NoColumns);
            layer.Close();

            string returnString = String.Empty;
            if (features.Count != 0)
            {
                returnString = features[0].GetWellKnownText();
            }

            return returnString;
        }

        public static ShapeFileFeatureLayer GetLayer()
        {
            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(HttpContext.Current.Server.MapPath("~/app_data/cntry02.shp"));
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1);
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            return worldLayer;
        }
    }
}
