﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.SilverlightEdition;
using System.Windows.Browser;
using Post5938.ServiceReference1;

namespace Post5938
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        private void Map1_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ServerLayerOverlay overlay = new ServerLayerOverlay("NativeServer", "SilverlightMapConnector1");
            Map1.Overlays.Add(overlay);

            InMemoryFeatureLayer highLightLayer = new InMemoryFeatureLayer();
            highLightLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(100, 60, 180, 60), GeoColor.GeographicColors.DeepOcean);
            highLightLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay highLightOverlay = new LayerOverlay();
            highLightOverlay.Layers.Add("layer", highLightLayer);
            Map1.Overlays.Add("overlay", highLightOverlay);

            Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
        }

        private void Map1_Click(object sender, MapClickEventArgs e)
        {
            WebService1SoapClient client = new WebService1SoapClient();
            client.GetFeatureByPositionAsync(e.WorldPoint.X, e.WorldPoint.Y);
            client.GetFeatureByPositionCompleted += new EventHandler<GetFeatureByPositionCompletedEventArgs>(client_GetFeatureByPositionCompleted); 
        }

        void client_GetFeatureByPositionCompleted(object sender, GetFeatureByPositionCompletedEventArgs e)
        {
            if (!String.IsNullOrEmpty(e.Result)) 
            {
                MultipolygonShape shape = new MultipolygonShape(e.Result);

                LayerOverlay overlay = (LayerOverlay)Map1.Overlays["overlay"];
                InMemoryFeatureLayer layer = (InMemoryFeatureLayer)overlay.Layers["layer"];
                layer.Open();
                layer.InternalFeatures.Clear();
                layer.InternalFeatures.Add(new Feature(shape));
                layer.Close();

                overlay.Refresh();
            }
        }
    }
}
